!**************************************************************
!*                                                            *
!*                SUBROUTINE LL2UTM                           *
!* @@@oܓxWUTMn}e̍Wɕϊ                *
!*         LLUTM.CC (GEOHYMOS) ̈ڐAł                 *
!*                                                            *
!**************************************************************
  SUBROUTINE ll2utm(LAMBDASEC,PHISEC,UE,UN,UTM)
!
  INTEGER LAMBDASEC       !  ox-->(yl̏ꍇPʂ10bj
  INTEGER PHISEC          !@ܓx-->(yl̏ꍇPʂ10bj
  DOUBLE PRECISION LAMBDA ! (ox,Pʂ͓x)
  DOUBLE PRECISION PHI    ! (ܓx,Pʂ͓x)-->(yl̏ꍇPʂ10bj
  DOUBLE PRECISION UE     !  UTM W,Pʂ M.
  DOUBLE PRECISION UN     ! k UTM W,Pʂ M.
  DOUBLE PRECISION CC     ! ΏۂƂ UTM ][qߐ(_)̌ox.Ⴆ΁A
                ! UTM ][̑ 53 т 132 x 138 x͈̔͂łA
                ! ̏ꍇ CC  135 Ƃ
!
  DOUBLE PRECISION PI, LAMBDA0, E2, ED2, A, B, B1, B2, B3
  DOUBLE PRECISION L, T2, GAMMA2, F, F1, F2, AA, BB, G, G1, G2
  INTEGER UTM
!
! yl̏ꍇPʂ10bxɕϊ
!
  LAMBDA = (LAMBDASEC/1.D1)/3.6D3
  PHI    = (PHISEC/1.D1)/3.6D3
!
!      UTM = 53
!  10  WRITE(*,*)'LAMBDA=? (0 FOR STOP)'
!      READ(*,*) LAMBDA
!      WRITE(*,*)'PHI=?'
!      READ(*,*) PHI
!      IF(LAMBDA.EQ.0)STOP
!
  CC = 0.D0
  IF(UTM.EQ.51) CC=123.D0
  IF(UTM.EQ.52) CC=129.D0
  IF(UTM.EQ.53) CC=135.D0
  IF(UTM.EQ.54) CC=141.D0
  IF(UTM.EQ.55) CC=147.D0
  IF(UTM.EQ.56) CC=153.D0
  IF(CC.EQ.0) WRITE(*,*)'WARNNING UTM ZONE'
!
  PI = 4.D0*ATAN(1.D0)
  E2 = 6.674372D-3         !/* ꗣŜQ */
  ED2 = 6.719219D-3  !/* 񗣐ŜQ */
  A = 6.377397155D3    !/* nȉ~̂̒a(KM) */
  B = 6.356078963D3    !/* nȉ~̂̒Za(KM) */
  LAMBDA0 = CC*PI/180.D0     !/* PʂWAɕϊ */
  LAMBDA = LAMBDA*PI/180.D0  !/* PʂWAɕϊ */
  PHI = PHI*PI/180.D0        !/* PʂWAɕϊ */
  AA = A/SQRT(1.D0-E2*SIN(PHI)**2.D0)
  B1 = 9.98329312962D-1
  B2 = 5.01415801D-3
  B3 = 1.049328D-5
  BB = A*(B1*PHI-B2*SIN(PHI)*COS(PHI)   &
     +B3*(SIN(PHI)*COS(PHI)**3.D0-SIN(PHI)**3.D0*COS(PHI)))
  L = LAMBDA-LAMBDA0
  T2 = TAN(PHI)**2.D0
  GAMMA2 = ED2*(COS(PHI)**2.D0)
  F1 = 1.D0-T2+GAMMA2
  F2 = 5.D0-18.D0*T2+T2**2.D0+14.D0*GAMMA2-58.D0*T2*GAMMA2
  F = AA*L*COS(PHI)*(1.D0+1.D0/6.D0*L**2.D0*COS(PHI)**2.D0    &
             *(F1+1.D0/20.D0*L**2.D0*COS(PHI)**2.D0*F2))
  G1 = 5.D0-T2+9.D0*GAMMA2+4.D0*GAMMA2**2.D0
  G2 = 61.D0-58.D0*T2+T2**2.D0+270.D0*GAMMA2-330.D0*T2*GAMMA2
  G = BB+5.0D-1*AA*L**2.D0*SIN(PHI)*COS(PHI) &
      *(1.D0+1.D0/12.D0*L**2.D0*COS(PHI)**2.D0 &
      *(G1+1.D0/30.D0*L**2.D0*COS(PHI)**2.D0*G2))
  UE = (9.996D-1*F+5.D2)*1.D3
  UN = (9.996D-1*G)*1.D3
!
!      WRITE(*,*) 'UE=',UE,'UN=',UN
!      GO TO 10
!      STOP
!
  RETURN
  END
